'A reference to the Phidget22.NET.dll must be added to new projects in VB.Net 
'From the "Project" menu select "Add Reference" 
'From the "Add Reference" window select the "Browse" tab 
'Browse to the directory you installed the Phidgets library to 
'The default is "C:\Program Files\Phidgets" 
'Select "Phidget22.NET.dll" and click "OK" 
'To view objects that have been added, select the "View" menu 
'Select "Object Browser" 
'Then expand the Phidget22.NET.dll item 



Imports Phidget22
Imports Phidget22.Events


Public Class Form1
    Dim WithEvents device As Phidget22.SoundSensor
    Dim open As ExampleUtils.ExampleUtils.CommandLineOpen
    Dim errorBox As ErrorEventBox
    Dim g2 As Graphics
    Dim bm As Bitmap

    Public Sub New()
        open = New ExampleUtils.ExampleUtils.CommandLineOpen(Me)
        Phidget22.Phidget.InvokeEventCallbacks = True
        InitializeComponent()
    End Sub

    Public Sub New(ByVal commandLine As String())
        open = New ExampleUtils.ExampleUtils.CommandLineOpen(Me)
        open.commandLine = commandLine

        InitializeComponent()
    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        device = New Phidget22.SoundSensor()

        Dim phidgetParameters As ExampleUtils.commandLineData = open.parseCmdLine()

        Try 'set all the values grabbed from command line.  these values have defaults that are set in ExampleUtils.vb, you can check there to see them
            device.Channel = phidgetParameters.Channel 'selects the channel on the device to open
            device.DeviceSerialNumber = phidgetParameters.SerialNumber 'selects the device or hub to open
            device.HubPort = phidgetParameters.HubPort 'selects th eport on the hub to open
            device.IsHubPortDevice = phidgetParameters.isHubPortDevice 'is the device a port on a vint hub?

            If phidgetParameters.isRemote Then 'are we trying to open a remote device?
                device.IsRemote = True
                Net.EnableServerDiscovery(ServerType.Device) 'turn on network scan
                If phidgetParameters.Password <> vbNullString And phidgetParameters.ServerName <> vbNullString Then
                    Net.SetServerPassword(phidgetParameters.ServerName, phidgetParameters.Password)
                End If
            Else
                device.IsLocal = True
            End If

            device.Open() 'open the device specified by the above parameters
        Catch ex As PhidgetException
            errorBox.addMessage("Error opening the device: " + ex.Message)
        End Try

        errorBox = New ErrorEventBox(Me)

        bm = New Bitmap(graphBox.Width, graphBox.Height)
        g2 = Graphics.FromImage(bm)
        g2.Clear(Color.White)
    End Sub

    Private Sub Form1_FormClosing(ByVal sender As Object, ByVal e As System.Windows.Forms.FormClosingEventArgs) Handles Me.FormClosing
        Application.DoEvents()
        If device.Attached Then
            device.Close()
        End If
    End Sub

    Private Sub graphBox_Paint(sender As Object, e As PaintEventArgs) Handles graphBox.Paint
        e.Graphics.DrawImage(bm, 0, 0)
    End Sub

    Private Sub graphBox_Resize(sender As Object, e As EventArgs) Handles graphBox.Resize
        bm = New Bitmap(graphBox.Width, graphBox.Height)
        g2 = Graphics.FromImage(bm)
        g2.Clear(Color.White)
    End Sub

    Private Sub sensor_Attach(ByVal sender As Object, ByVal e As Phidget22.Events.AttachEventArgs) Handles device.Attach
        PhidgetInfoBox1.FillPhidgetInfo(CType(sender, Phidget))
        Dim attachedDevice As SoundSensor = CType(sender, SoundSensor)

        Try
            attachedDevice.SPLRange = SPLRange.dB_102
            dataIntervalTrk.Unit = "ms"
            dataIntervalTrk.minTxt = attachedDevice.MinDataInterval.ToString()
            dataIntervalTrk.maxTxt = attachedDevice.MaxDataInterval.ToString()
            dataIntervalTrk.Minimum = attachedDevice.MinDataInterval
            dataIntervalTrk.Maximum = attachedDevice.MaxDataInterval
            dataIntervalTrk.Value = attachedDevice.DataInterval
            changeTriggerTrk.Unit = "dB"
            changeTriggerTrk.minTxt = attachedDevice.MinSPLChangeTrigger.ToString()
            changeTriggerTrk.maxTxt = attachedDevice.MaxSPLChangeTrigger.ToString()
            changeTriggerTrk.Minimum = attachedDevice.MinSPLChangeTrigger
            changeTriggerTrk.Maximum = attachedDevice.MaxSPLChangeTrigger
            changeTriggerTrk.Value = attachedDevice.SPLChangeTrigger
        Catch ex As PhidgetException
            errorBox.addMessage("Error initializing device: " + ex.Message)
        End Try

        splRangeCombo.DataSource = [Enum].GetValues(GetType(SPLRange))
        splRangeCombo.SelectedIndex = 0

        settingsBox.Visible = True
        outputBox.Visible = True
        testUtilityBox.Visible = True
        frequencyPanel.Visible = True
        groupBox1.Visible = True
        frequencyTrk.Value = 1000
        bckgndWorker1Status.Text = frequencyTrk.Value.ToString() + " Hz"
    End Sub

    Private Sub sensor_Detach(ByVal sender As Object, ByVal e As Phidget22.Events.DetachEventArgs) Handles device.Detach
        PhidgetInfoBox1.Clear()

        settingsBox.Visible = False
        outputBox.Visible = False
        testUtilityBox.Visible = False
        frequencyPanel.Visible = False
        groupBox1.Visible = False
    End Sub

    Private Sub sensor_Error(ByVal sender As Object, ByVal e As Phidget22.Events.ErrorEventArgs) Handles device.Error
        errorBox.addMessage(e.Description)
    End Sub

    Dim myBrush As SolidBrush = New SolidBrush(Color.Red)
    Private Sub sensor_Change(ByVal sender As Object, ByVal e As Phidget22.Events.SoundSensorSPLChangeEventArgs) Handles device.SPLChange
        Try
            dBTxt.Text = e.DB.ToString("F3")
            dBATxt.Text = e.DBA.ToString("F3")
            dBCTxt.Text = e.DBC.ToString("F3")

            g2.Clear(Color.White)

            Dim Width As Single = bm.Width / e.Octaves.Length

            For i As Integer = 0 To e.Octaves.Length - 1
                Dim Height As Single = CType((e.Octaves(i) / device.MaxdB * bm.Height), Double)
                g2.DrawRectangle(New Pen(Color.Red, 2), i * Width, bm.Height - Height, Width, Height)
            Next i
            graphBox.Invalidate()

            val16k.Text = e.Octaves(0).ToString("F")
            val8k.Text = e.Octaves(1).ToString("F")
            val4k.Text = e.Octaves(2).ToString("F")
            val2k.Text = e.Octaves(3).ToString("F")
            val1k.Text = e.Octaves(4).ToString("F")
            val500.Text = e.Octaves(5).ToString("F")
            val250.Text = e.Octaves(6).ToString("F")
            val125.Text = e.Octaves(7).ToString("F")
            val63.Text = e.Octaves(8).ToString("F")
            val32.Text = e.Octaves(9).ToString("F")
        Catch ex As PhidgetException
            errorBox.addMessage(ex.Description)
        End Try
    End Sub

    Private Sub frequencyTrk_Scroll(sender As Object, e As EventArgs) Handles frequencyTrk.Scroll
        bckgndWorker1Status.Text = frequencyTrk.Value.ToString() + " Hz"
    End Sub

    Private Sub AsyncWorker_Click(sender As Object, e As EventArgs) Handles AsyncWorker.Click
        AsyncWorker.Enabled = False
        If Not backgroundWorker1.IsBusy Then
            backgroundWorker1.RunWorkerAsync(frequencyTrk.Value)
        End If
    End Sub

    Private Sub backgroundWorker1_DoWork(sender As Object, e As System.ComponentModel.DoWorkEventArgs) Handles backgroundWorker1.DoWork
        Console.Beep(CType(e.Argument, Integer), 2500)
    End Sub

    Private Sub backgroundWorker1_RunWorkerCompleted(sender As Object, e As System.ComponentModel.RunWorkerCompletedEventArgs) Handles backgroundWorker1.RunWorkerCompleted
        AsyncWorker.Enabled = True
    End Sub

    Private Sub dataIntervalTrk_Scroll(sender As Object, e As EventArgs) Handles dataIntervalTrk.LogScroll
        If (MouseButtons = MouseButtons.Left) Then
            Try
                device.DataInterval = CType(dataIntervalTrk.Value, Integer)
            Catch ex As Exception
                errorBox.addMessage("Error setting data interval: " + ex.Message)
            End Try
        End If
    End Sub

    Private Sub dataIntervalTrk_LogMouseUp(sender As Object, e As EventArgs) Handles dataIntervalTrk.LogMouseUp
        Try
            device.DataInterval = CType(dataIntervalTrk.Value, Integer)
        Catch ex As Exception
            errorBox.addMessage("Error setting data interval: " + ex.Message)
        End Try
    End Sub

    Private Sub changeTriggertrk_Scroll(sender As Object, e As EventArgs) Handles changeTriggerTrk.LogScroll
        If (MouseButtons = MouseButtons.Left) Then
            Try
                device.SPLChangeTrigger = CType(changeTriggerTrk.Value, Integer)
            Catch ex As Exception
                errorBox.addMessage("Error setting data interval: " + ex.Message)
            End Try
        End If
    End Sub

    Private Sub changeTriggerTrk_LogMouseUp(sender As Object, e As EventArgs) Handles changeTriggerTrk.LogMouseUp
        Try
            device.SPLChangeTrigger = CType(changeTriggerTrk.Value, Integer)
        Catch ex As Exception
            errorBox.addMessage("Error setting data interval: " + ex.Message)
        End Try
    End Sub

    Private Sub splRangeCombo_SelectedIndexChanged(sender As Object, e As EventArgs) Handles splRangeCombo.SelectedIndexChanged
        Dim box As ComboBox = CType(sender, ComboBox)
        If box.SelectedIndex = 0 Then
            device.SPLRange = SPLRange.dB_102
        Else
            device.SPLRange = SPLRange.dB_82
        End If
    End Sub
End Class



